/*
 * SlowArrowHelpPanel.java    
 * Version 2.2
 * 2001/10/17
 * Written by Victor Liu See-le <victor@n-gon.com>
 * Copyright GPL
 */

package TheSlowArrowofBeauty;

import java.awt.*;

/**
 * class SlowArrowHelpPanel
 *
 * Popup for help info
 */
class SlowArrowHelpPanel extends Panel {

    private SlowArrow parent;
    private Image helpImage = null;
    private int helpImageX;
    private int helpImageY;
    private SlowArrowHelpPanelKiller killer;

    SlowArrowHelpPanel(SlowArrow parent) {
        this.parent = parent;
        String imageFile = parent.conf.getStringProperty("helpPanelImageFile");
        int w = parent.conf.getIntegerProperty("helpPanelWidth");
        int h = parent.conf.getIntegerProperty("helpPanelHeight");
        helpImageX = parent.conf.getIntegerProperty("helpPanelImageX");
        helpImageY = parent.conf.getIntegerProperty("helpPanelImageY");
        Color backC = parent.conf.getColorProperty("helpPanelBackColor");
        try {
            helpImage = parent.rcm.getImage(imageFile);
        } catch (java.io.IOException e) {
            if (Debug.DEBUGGING_ON) {
                System.err.println("Error reading from image file " + imageFile);
                e.printStackTrace();
            }
        }
        setBounds(0, 0, w, h);
        parent.center(this);
        setBackground(backC);

        int killerX = 
                parent.conf.getIntegerProperty("helpPanelKillerX");
        int killerY = 
                parent.conf.getIntegerProperty("helpPanelKillerY");
        int killerW = 
                parent.conf.getIntegerProperty("helpPanelKillerWidth");
        int killerH = 
                parent.conf.getIntegerProperty("helpPanelKillerHeight");
        int killerSlideExtentX = 
                parent.conf.getIntegerProperty("helpPanelKillerSlideExtentX");
        int killerSlideExtentY = 
                parent.conf.getIntegerProperty("helpPanelKillerSlideExtentY");
        int killerSlideSteps = 
                parent.conf.getIntegerProperty("helpPanelKillerSlideSteps");
        int killerSlideDelay = 
                parent.conf.getIntegerProperty("helpPanelKillerSlideDelay");
                
        Point killerOrigin = new Point(killerX, killerY);
        Point killerSlideExtent = new Point(killerSlideExtentX, 
                                            killerSlideExtentY);
        killer = new SlowArrowHelpPanelKiller(killerOrigin,
                                              killerSlideExtent,
                                              killerSlideSteps,
                                              killerSlideDelay,
                                              parent);
        killer.setBounds(killerX, killerY, killerW, killerH);
        add(killer);
    }

    public void paint(Graphics g) {
        g.drawImage(helpImage, helpImageX, helpImageY, this);
    }

    public void update(Graphics g) {
        paint(g);
    }
}
