/*
 * SlowArrowProgressIndicatorTimer.java
 * Version 2.2
 * 2001/10/17
 * Written by Victor Liu See-le <victor@n-gon.com>
 * Copyright GPL
 */

package TheSlowArrowofBeauty;

/*
 * class SlowArrowProgressIndicatorTimer
 *
 * Self-explanatory
 */
class SlowArrowProgressIndicatorTimer implements Runnable {

    private int numDisplays;
    private SlowArrow parent;
    private int delay;
    private Thread timer = null;

    SlowArrowProgressIndicatorTimer(SlowArrow parent) {
        this.parent = parent;
        String prop = "progressIndicatorTimerRefresh";
        delay = parent.conf.getIntegerProperty(prop);
        numDisplays = parent.conf.getIntegerProperty("numDisplays");
    }

    public void start() {
        timer = new Thread(this);
        timer.start();
    }

    public void run() {
        Thread currentThread = Thread.currentThread();
        while (currentThread == timer) {
            for (int i = 0; i < numDisplays; i++) {
                if ((parent.p[i] != null) && !(parent.p[i].isDisabled)) {
                    parent.p[i].trigger();
                }
            }
            try {
                Thread.sleep(delay);
            } catch(InterruptedException e) {}
        }
    }

    public synchronized void stop() {
		if (timer != null) {
		    Thread moribund = timer;
		    timer = null;
		    moribund.interrupt();
		}
    }
}
