/*
 * Timer.java    
 * Version 2.2
 * 2001/10/17
 * Written by Victor Liu See-le <victor@n-gon.com>
 * Copyright GPL
 */

package TheSlowArrowofBeauty;

/*
 * class Timer
 * 
 * General purpose timer
 */
class Timer extends Thread {

    protected TimerListener notifyTarget;
    protected int delay;
    protected int loops;
    protected int loopCount;

    /* Set loops = -1 to go on forever */
    Timer(TimerListener notifyTarget, int delay, int loops) {
        this.notifyTarget = notifyTarget;
        this.delay = delay;
        this.loops = loops;
        loopCount = 0;
    }

    public void run() {
        while (true) {
            try {
                Thread.sleep(delay);
            } catch (InterruptedException e) {
                return;
            }
            notifyTarget.timerTriggered();
            if (loopCount++ == loops) {
                return;
            }
        }
    }
}
